C     -------------------------------------------------------------------   
      PROGRAM P2DCRY                                                    
C     ---------------------------------------------------------------   
C     
C     This program is a special version of PLOTDEN, reading a file in
C     SURFER format and a file which contains only information on number of
C     nuclear centers and their positions.
C     The program has been written in September 1992 by Carlo Gatti, University
C     of MILANO.
C     The program has been changed in March 1994 by Carlo Gatti, in order
C     to add the capability of tracing out the grad(rho) trajectories or 
C     to plot a molecular graph. Additionally a molecular graph can be 
C     superimposed on rho or Laplacian plots.
C     Further extension (september 1995) to include ELF 
C     and magnitude of grad(rho) plots.
C     Further extension (april 97) to include density, Laplacian density
C     ELF function differences
C     Further extension (april 97) to include virial density 
C     kinetic energy densities, (rhoa-rhob) plots
     
                                                                        
C     the output (informations on the run) is sent to  file 6
C     while the input for plotter is sent to file 99 (2D-plot)

C     NFUN=1  Rho
C     NFUN=2  (+-) Laplacian of rho
C     NFUN=3  Magnitude of the gradient of rho
C     NFUN=4  ELF
C     NFUN=5  Virial field density
C     NFUN=6  Lagrangian Kinetic Energy Density G(r)
C     NFUN=7  Hamiltonian Kinetic Energy Density K(r)
C     NFUN=8  Spin density (rhoa-rhob)
C     NFUN=9  Electron density difference (fort.11 -fort.10)
C     NFUN=10 Laplacian density difference (fort.11-fort.10)
C     NFUN=11 ELF function difference (fort.11-fort.10)
C     NFUN=12 Rho + Molecular graph
C     NFUN=13 (+-) Laplacian of rho + Molecular graph
C     NFUN=14 Molecular graph
C     NFUN=15 Grad Rho Trajectories
  

      IMPLICIT DOUBLE PRECISION (A-H,O-Z)                               
      CHARACTER*80  NAME 
                                                                        
      COMMON/INFGRA/ NAME,IPSIZE,IXSYM,IYSYM,ICONT,IDIF,IOVER,          
     *               IPLOT3D,NFUN                                       

      PARAMETER (MAXDIM=40000)                                          
      PARAMETER (MAXX  = 400 )                                          
      PARAMETER (IN    = 5   )                                          
      PARAMETER (IOU   = 6   )                                          
                                                                        
C     MAXDIM = dimension of vector CO 
C     MAXX   = maximum number of grid points along X                    
                                                                        
      COMMON/PROEXT/CO(MAXDIM)                                          
                                                                        
      COMMON MODE,NMO,NPRIMS,NCENT                                      
                                                                        
      COMMON/PARAM/ MAXD,MAXXP,ILE                                      
                                                                        
      COMMON /HP7550/ IOUT                                              
                                                                        
      COMMON/IO/ INN,IOUU                                               
                                                                        
      COMMON/UNITS/ IU5,IU6,IU16
                                                                        
      COMMON/DISC/ FUN1(MAXX),FUN2(MAXX)                                
       
      COMMON/SIZE/MAXDD

      DATA DEFAU/.20/

      IOUT=99                                                                  
      MAXD=MAXDIM                                                       
      MAXDD=MAXDIM                                                       
      MAXXP=MAXX                                                        
      ILE=ILET                                                          
      INN=IN                                                            
      IOUU=IOU                                                          
      IU5=5                                                             
      IU6=6                                                             
                                                                        
C     reads the input information
                                                                        
      CALL INPUT                                                        
                                                                        
C     print some plot characteristics                                   
                                                                        
      CALL OUTPUT                                                       
                                                                        
C     initializes plotter 

      CALL PTHICK(DEFAU)
                                                                        
      CALL PREPLOT                                                      
                                                                        
C     evaluates the function values at the grid positions               
      
      IF(NFUN.GE.14) GO TO 1
      CALL RFILSUR(FUN1,FUN2,NFUN,IDIF)                                            
                                                                        
C     plots  plot-label, borders, nuclear positions, define window                    
1     CALL MAP                                                          
                                                                        
C     determines and plots contour plots of the chosen scalar           
C     function                                                          
                                                                        
      IF(NFUN.LE.13) THEN    
      CALL PLCON
      IF(NFUN.GT.11)CALL TRPATH
      ELSE
      CALL TRPATH
      ENDIF
C     ends the plot                                                     
      CALL PLT_ENDLASER (IOUT)                                               
      STOP                                                              
      END                                                               
C     ----------------------------------------------------------------- 
      SUBROUTINE INPUT                                                  
C     ----------------------------------------------------------------- 
                                                                        
                                                                        
      implicit double precision (a-h,o-z)                               
                                                                        
      LOGICAL IEX                                                       
      CHARACTER*64 IFILE,IPSIF1,IPSIF2,IFILE3D,IFPLOT,ISASUR
      CHARACTER*80  NAME 


      COMMON/INFGRA/ NAME,IPSIZE,IXSYM,IYSYM,ICONT,IDIF,IOVER,          
     *               IPLOT3D,NFUN                                       
                                                                        
      COMMON/INFDIM/ XLEN,YLEN,XINC,YINC,SCALE,X0,Y0,Z0,EULER1,         
     *               EULER2,EULER3,NXPOINT,NYPOINT                      
                                                                        
      COMMON/INFFIL/ IFILE,IPSIF1,IPSIF2,IFILE3D,IFPLOT,ISASUR  
                                                                        
      COMMON/IOVERL/ XORIG (80),YORIG (80),ZORIG (80),ILAMBDA(80)       
     *               ,NORIG,IPLANE                                      
                                                                        
      COMMON/UNITS/ IU5,IU6,IU16

      COMMON/EXCC/ ECONT(50),NEXTRA,NCONT                               
                                                                        
      COMMON/RFERM / XREF,YREF,ZREF,IMUL                                
                                                                        
      COMMON/PARAM/ MAXDIM,MAXX,ILET                                    

      COMMON/UPDOWN/XMIN,XMAX,YMIN,YMAX               
 
      COMMON MODE,NMO,NPRIMS,NCENT                                      

      COMMON/OFFSET/ITYPE,ICENT,KATOM,IEORB,IE,IMO,ICHARG,IXC,IYC,IZC,  
     +IXX,IYY,IZZ,IXS,IYS,IZS,IRR,IR2,IP,IPSI,IGX,IGY,IGZ,ID2           
                                                                        
      COMMON/PROEXT/CO(1)

                                                                        
      DATA IU1,IU3 /1,3/                                  

                                                                        
 1000 FORMAT (A80)                                                      
 1001 FORMAT (40I2)                                                     
 1002 FORMAT (6G13.5)                                                   
 1003 FORMAT (2A40)                                                     
 1004 FORMAT (3G13.5,I2)                                                
 1005 FORMAT (1X,'SELECT THE PROPER VALUE OF NFUN')
                                                                        
      IFILE3D = 'ITEMP'                                                 
                                                                        
C     reads the input from unit 5                                
C     unit 5 : input file prepared by CRYSTAL-95
C                                                                       
                                                                        
                                                                        
                                                                        
      READ (IU5,1000) NAME                                              
      READ (IU5,1001) IPSIZE                                            
      READ (IU5,1002) XLEN,YLEN,SCALE                         
      READ (IU5,1002) X0,Y0,Z0,EULER1,EULER2,EULER3                     
      READ (IU5,1002) XMIN,XMAX,XINC           
      READ (IU5,1002) YMIN,YMAX,YINC                     
      READ (IU5,1001) IXSYM,IYSYM                                       
      READ (IU5,1001) NFUN                                              
      IF(NFUN.EQ.-1)THEN
      WRITE(IU6,1005)
      STOP
      ENDIF
      READ(IU5,*) NCENT
      IXC=0
      IYC=IXC+NCENT
      IZC=IYC+NCENT
      DO 1 I=1,NCENT
      READ(IU5,*) CO(IXC+I),CO(IYC+I),CO(IZC+I)
 1    CONTINUE
      IF(NFUN.GE.14) RETURN

      CALL SETCONT 

      NX=(XLEN/XINC +1.1)*8       ! recl in bytes                       
                                                                        
      OPEN (UNIT=IU3,FILE= IFILE3D , STATUS='UNKNOWN',                  
     *ACCESS='DIRECT',FORM='UNFORMATTED',RECL=NX)                       

      RETURN                                                            
      END                                                               
                                                                        
C     ----------------------------------------------------------------- 
      SUBROUTINE SETCONT
C     ----------------------------------------------------------------- 
                                                                        
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)                               
      CHARACTER*80 NAME
                                                                        
                                                                        
C     defines the contour lines for each scalar function                
                                                                        
      COMMON/INFGRA/ NAME,IPSIZE,IXSYM,IYSYM,ICONT,IDIF,IOVER,          
     *               IPLOT3D,NFUN                                       
                                                                        
      COMMON/EXCC/ ECONT(50),NEXTRA,NCONT                               
                                                                        
      DIMENSION CTR1(13),CTR2(24),CTR3(21),CTR4(41),CTR1DIF(31)                              
      DATA NCTR1,NCTR2,NCTR3,NCTR4,NCTR1DIF /13,24,20,41,31/                                 
      DATA CTR1/.002,.004,.008,.02,.04,.08,.2,.4,.8,2.,4.,8.,20./    

      DATA CTR1DIF/0.,
     *.0002,-.0002,.0004,-.0004,.0008,-.0008,
     *.002,-.002,.004,-.004,.008,-.008,.02,-.02,.04,
     *-.04,.08,-.08,.2,-.2,.4,-.4,.8,-.8,2.,-2.,4.,-4.,8.,-8./
      DATA CTR2/-.002,.002,-.004,.004,-.008,.008,-.02,.02,           
     *-.04,.04,-.08,.08,-.2,.2,-.4,.4,-.8,.8,-2.,2.,-4.,4.,-8.,8./      
      DATA CTR3/0.,-.05,.05,-.1,.1,-.15,.15,-.20,.20,-.25,.25,-.30,
     *.30,-.35,.35,-.4,.4,-.45,.45,-.5,.5/
      DATA CTR4/1.0,.95,.90,.85,.80,.75,.70,.65,.60,.55,.50,
     *.45,.40,.35,.30,.25,.20,.15,.10,.05,0.,
     *-1.0,-.95,-.90,-.85,-.80,-.75,-.70,-.65,-.60,-.55,-.50,
     *-.45,-.40,-.35,-.30,-.25,-.20,-.15,-.10,-.05/
C     In this way in ELF we have :
C     dashed lines for ELF.LE.0.5 
C     full lines   for ELF.GT.0.5
                                                                        
C     Default contour values                                            
                                                                        
C     Rho,G,Fermi hole,LG,transition density,user defined function      
C     CTR1                                                              
C     .002,.004,.008,.02,.04,.08,.2,.4,.8,2.,4.,8.,20.
C
C     for the difference of two wavefunctions see CTR1DIF ( positive and
C     negative values must be considered ) and multiply the corresponding
C     values by CFACT
 
                                                                        
C     K,Laplacian                                                       
C     CTR2                                                              
C     0.,+-.002,+-.004,+-.008,+-.02,+-.04,+-.08,+-.2,+-.4,+-.8          
C     +-2.,+-4.,+-8.                                                    
                                                                        
C     ELF (see CTR3)                                                     
                                                                        
      IF((NFUN.LT.8).OR.(NFUN.GE.12))THEN
      IDIF=0
      ELSE
      IDIF=1
      ENDIF
      FACT=1.D0
      NEXTRA=0                                                          
                                                                        
      GO TO (2001,2002,2001,2003,2002,2001,2002,2001,2001,
     *2001,2003,2001,2002),NFUN         
                                                                        
 2001 IF(IDIF.EQ.1) THEN
      NUP=NCTR1DIF
      DO  2 I=1,NUP
 2    ECONT(I+NEXTRA) = CTR1DIF(I)*FACT 
      ELSE
      NUP=NCTR1
      DO  22 I=1,NUP
 22   ECONT(I+NEXTRA) = CTR1(I)*FACT                                    
      ENDIF

      NCONT=NUP+NEXTRA                                                
      GO TO 100                                                         
                                                                        
 2002 DO 3 I=1,NCTR2                                                    
 3    ECONT(I+NEXTRA) = CTR2(I)*FACT                                    
      NCONT=NCTR2+NEXTRA                                                
      GO TO 100                                                         
C                                                                       
 2003 IF(IDIF.EQ.0) THEN
      DO 4 I=1,NCTR3                                                    
 4    ECONT(I+NEXTRA) = CTR3(I)*FACT 
      NCONT=NCTR3+NEXTRA                                                
      ELSE
      DO 5 I=1,NCTR4
 5    ECONT(I+NEXTRA)=CTR4(I)
      NCONT=NCTR4+NEXTRA                                                
      ENDIF
 100  CONTINUE                                                          
      IF(NFUN.EQ.8)THEN
      IDIF=0
      ENDIF
      RETURN                                                            
      END                                                               
C     ------------------------------------------------------------------
      SUBROUTINE PREPLOT                                                
C     ------------------------------------------------------------------
                                                                        
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)                               
                                                                        
      CHARACTER*2 SIZE                                                  
      CHARACTER*80 NAME
      CHARACTER*64 IFILE,IPSIF1,IPSIF2,IFILE3D,IFPLOT,ISASUR
                                                                        
      COMMON/INFFIL/ IFILE,IPSIF1,IPSIF2,IFILE3D,IFPLOT,ISASUR
                                                                        
      COMMON/INFGRA/ NAME,IPSIZE,IXSYM,IYSYM,ICONT,IDIF,IOVER,          
     *               IPLOT3D,NFUN                                       
                                                                        
      COMMON/INFDIM/ XLEN,YLEN,XINC,YINC,SCALE,X0,Y0,Z0,EULER1,         
     *               EULER2,EULER3,NXPOINT,NYPOINT                      
                                                                        
      COMMON/PLOTDIM/ XXLEN,YYLEN,HALFXL,HALFYL,SX,SY    
                                                                        
      COMMON/STUFF/ PI,RADIAN,DEGREE                                    
                                                                        
      COMMON/HP7550/ IOUT                                               
                                                                        
      DIMENSION SIZE (2)
                                                                        
      DATA HALF/0.5D0/                                                  
      DATA SIZE/'A3','A4'/                                              
                                                                        
C     initializes the plotter, open the output unit 99 for plotter      
                                                                        
      IFPLOT='PL2D'
      OPEN (UNIT=IOUT,FILE=IFPLOT           ,STATUS='UNKNOWN',          
     *ACCESS='SEQUENTIAL',                               
     *FORM='FORMATTED',IOSTAT=IOS)                                      
      CALL CHECKIOS(IOS)                                                
                                                                        
      CALL PLT_INLASER (IOUT)                                              
                                                                        
      XXLEN= XLEN/SCALE
      YYLEN= YLEN/SCALE
      HALFXL= XXLEN*HALF                                                 
      HALFYL= YYLEN*HALF                                                 
                                                                        
                                                                        
C     xlen,ylen : x,y length in au of plot                              
C     xxlen,yylen : x,y length in cm 
C     scale     : au/cm of plot                                         
                                                                        
                                                                        
C     defines the user area in order to have homogeneous coordinates    
C     on X and Y                                                        
                                                                        
      CALL OCAREA (0.D0,XXLEN,0.D0,YYLEN,SIZE(IPSIZE),IOUT,SX,SY)         
                                                                        
C     calculates the rotation matrix for the Euler angles in order      
C     to transform the molecular coordinates on the X,Y plot            
C     reference frame                                                   
                                                                        
      PI= 3.14159265359                                                 
      RADIAN= .017453292519                                             
      DEGREE= 57.29577951307                                            
                                                                        
      CALL RMATRX (EULER1,EULER2,EULER3)                                
                                                                        
C     appends to the plot label title the name of the scalar            
C     field to be plotted                                               
                                                                        
      CALL APTITLE 
                                                                        
      RETURN                                                            
      END                                                               
                                                                        
C     ------------------------------------------------------------------
      SUBROUTINE MAP                                                    
C     ------------------------------------------------------------------
C                                                                       
C     PLOTS BORDERS AND NUCLEI; DEFINE WINDOW                           
C                                                                       
C     ------------------------------------------------------------------
      implicit double precision (a-h,o-z)                               
                                                                        
      INTEGER*4 SITE(20),ISTR(20),INFO(20),LABE(20),NAM(20)                              
      CHARACTER*80 STRING                                               
      CHARACTER*80 NAME                                                 
      CHARACTER*80 LABEL                                                 
      CHARACTER*80 INFOC                                                 
      CHARACTER*80 SITEC                                                 
                                                                        
      COMMON/PROEXT/CO(1)                                               
                                                                        
      COMMON/INFGRA/ NAME,IPSIZE,IXSYM,IYSYM,ICONT,IDIF,IOVER,          
     *               IPLOT3D,NFUN                                       
                                                                        
      COMMON/INFDIM/ XLEN,YLEN,XINC,YINC,SCALE,X0,Y0,Z0,EULER1,         
     *               EULER2,EULER3,NXPOINT,NYPOINT                      
                                                                        
      COMMON/PLOTDIM/ XXLEN,YYLEN,HALFXL,HALFYL,
     *SX,SY                                                             
                                                                        

      COMMON /HP7550/ IOUT                                              
                                                                        
      COMMON/RFERM / XREF,YREF,ZREF,IMUL                                
                                                                        
      COMMON/OFFSET/ITYPE,ICENT,KATOM,IEORB,IE,IMO,ICHARG,IXC,IYC,IZC,  
     +IXX,IYY,IZZ,IXS,IYS,IZS,IRR,IR2,IP,IPSI,IGX,IGY,IGZ,ID2           
                                                                        
      COMMON MODE,NMO,NPRIMS,NCENT                                      
                                                                        
      COMMON /C8/ LABEL
                                                                        
      COMMON/AMATRX/A11,A12,A13,A21,A22,A23,A31,A32,A33                 
                                                                        
      EQUIVALENCE (ISTR(1),STRING)                                      
      EQUIVALENCE (INFO(1),INFOC)                                      
      EQUIVALENCE (SITE(1),SITEC)                                      
      EQUIVALENCE (LABE(1),LABEL)                                      
      EQUIVALENCE (NAM(1),NAME)                                      
                                                                        
      DATA SITE / 4HCNR , 4HCent, 4Her f, 4Hor t, 4Hhe S,               
     $            4Htudy, 4H of , 4HStru, 4Hctur, 4He/Re,               
     $            4Hacti, 4Hvity, 4H Rel, 4Hatio, 4Hns -,               
     $            4H Mil, 4Hano , 4H- It, 4Haly , 4H    /               
                                                                        
      DATA INFO / 4H   X,4Hlen ,4H(cm),4H    ,4H  Yl,4Hen(c,            
     $            4Hm)  ,4H    ,4HXinc,4H(cm),4H    ,4H  Yi,            
     $            4Hnc(c,4Hm)  ,4H    ,4HScal,4He(An,4Hg/cm,            
     $            4H)   ,4H    /                                        

      DATA CONV /.529177/
C                                                                       
C    DETERMINE PLOT SIZE, LETTERING SIZE, ETC..                         
C                                                                       
      FSHEET=1.D0                                                       
      IF (IPSIZE.EQ.1 ) FSHEET=1.5                                      
      FACT=1.D0*FSHEET                                                  
      XXX=XXLEN                                                          
      IF(XXLEN.LT.YYLEN)FACT=-FACT                                        
      IF(XXLEN.LT.YYLEN)XXX=0.D0                                          
                                                                        
      XBOX=2.D0                                                         
      HLET=.18D0*FSHEET                                                 
      WLET=HLET*.76D0                                                   
      YBOX=WLET*77.D0*1.5                                               
                                                                        
      IF(YBOX.GT.YYLEN) WLET=WLET*YYLEN/YBOX                              
      IF (YBOX.GT.YYLEN) YBOX=YYLEN                                       
      XLET0=HLET*0.5D0                                                  
      XLET1=XBOX*0.200D0+HLET*0.5D0                                     
      XLET2=XBOX*0.400D0+HLET*0.5D0                                     
      XLET3=XBOX*0.600D0+HLET*0.5D0                                     
      XLET4=XBOX*0.800D0+HLET*0.5D0                                     
      YYY=(YYLEN-YBOX)*0.5D0                                             
      IF (YYY.LT.0.D0) YYY=0.D0                                         
      IF (XXLEN.LT.YYLEN) GO TO 10                                        
      X1=XXX+FACT*(XBOX+.5D0 -XLET4)                                    
      X2=XXX+FACT*(XBOX+.5D0 -XLET3)                                    
      X3=XXX+FACT*(XBOX+.5D0 -XLET2)                                    
      X4=XXX+FACT*(XBOX+.5D0 -XLET1)                                    
      X5=XXX+FACT*(XBOX+.5D0 -XLET0)                                    
      GO TO 11                                                          
 10   CONTINUE                                                          
      X1=XXX+FACT*(XBOX+.5D0 -XLET0-.26)                                
      X2=XXX+FACT*(XBOX+.5D0 -XLET1-.26)                                
      X3=XXX+FACT*(XBOX+.5D0 -XLET2-.26)                                
      X4=XXX+FACT*(XBOX+.5D0 -XLET3-.26)                                
      X5=XXX+FACT*(XBOX+.5D0 -XLET4-.26)                                
 11   Y1=YYY+0.035                                                      
      Y2=Y1                                                             
      Y3=Y1                                                             
      Y4=Y1                                                             
      Y5=Y1                                                             
C                                                                       
C    WRITE PLOT LABEL.                                                  
C                                                                       
                                                                        
C     put the plot label on the longer sheet side , in any case         
                                                                        
csil      CALL PLOT (XXX+FACT*.5D0,YYY,3)                                   
csil      CALL PLOT (XXX+FACT*.5D0,YYY+YBOX,2)                              
csil      CALL PLOT (XXX+FACT*(.5D0+XBOX),YYY+YBOX,2)                       
csil      CALL PLOT (XXX+FACT*(.5D0+XBOX),YYY,2)                            
csil      CALL PLOT (XXX+FACT*.5D0,YYY,2)                                   
      ILEN=LEN(LABEL)
csil     CALL LETTER(ILEN,HLET,WLET,90.D0,X1,Y1,LABE)                       
      ILEN=LEN(NAME)
csil     CALL LETTER(ILEN,HLET,WLET,90.D0,X2,Y2,NAM)                       
      WRITE (STRING,'(5(3X,F5.2,7X))') XXLEN,YYLEN,XINC/SCALE,
     *                                 YINC/SCALE,SCALE*CONV        
      ILEN=LEN(INFOC)
csil  CALL LETTER (ILEN,HLET,WLET,90.D0,X3,Y3,INFO)                       
      ILEN=LEN(STRING)
csil  CALL LETTER (ILEN,HLET,WLET,90.D0,X4,Y4,ISTR)                       
      ILEN=LEN(SITEC)
csil  CALL LETTER(ILEN,HLET,WLET,90.D0,X5,Y5,SITE)                        
C                                                                       
C    PLOT BORDERS                                                       
C                                                                       
      CALL PLOT(0.D0,0.D0,3)                                            
      CALL PLOT(0.D0,YYLEN,2)                                            
      CALL PLOT(XXLEN,YYLEN,2)                                            
      CALL PLOT(XXLEN,0.D0,2)                                            
      CALL PLOT(0.D0,0.D0,2)                                            

C     defines the window where is possible to plot                      
                                                                        
      CALL WINDOW (0.D0,XXLEN,0.D0,YYLEN,IOUT)                            
                                                                        
C                                                                       
C    PLOT NUCLEAR POSITIONS.                                            
C                                                                       
      DO 2 I=1,NCENT                                                    
C                                                                       
C     transform nuclear coordinates to plot coordinates                 
C                                                                       
      XXX=CO(IXC+I)                                                     
      YYY=CO(IYC+I)                                                     
      ZZZ=CO(IZC+I)                                                     
                                                                        
      CALL TRCOORD(XXX,YYY,ZZZ,XN,YN,ZN)                                

C     nuclei in the plot xy plane denoted by cross                      
C     nuclei not in the xy plane denoted by cross... not crossing       

      IF((XN.GT.XXLEN).OR.(YN.GT.YYLEN)) GO TO 2
                                                                        
      CALL NUCLEI ( XN,YN,ZN )                                          
                                                                        
    2 CONTINUE                                                          

      RETURN                                                            
      END                                                               
                                                                        
C     ------------------------------------------------------------------
      SUBROUTINE APTITLE                                                
C     ----------------------------------------------------------------- 
                                                                        
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)                               
      CHARACTER*80 NAME                                                 
                                                                        
      COMMON/INFGRA/ NAME,IPSIZE,IXSYM,IYSYM,ICONT,IDIF,IOVER,          
     *               IPLOT3D,NFUN                                       
                                                                        
      DIMENSION NAMEF(45)                                      
      DIMENSION NAMEI(20)
      
      EQUIVALENCE (NAME,NAMEI(1))

      DATA NAMEF /4H Rho,4H    ,4H    ,
     *4HLapl,4Hac. ,4H    ,4HMagn,4H.Gra,4Hdrho,
     *4H ELF,4H    ,4H    ,4HViri,4Hal D,4Hens.,
     *4HG(r),4H    ,4H    ,4HK(r),4H    ,4H    ,
     *4HRhoa,4H-Rho,4Hb   ,4HRho1,4H-Rho,4H2   ,
     *4HLap1,4H-Lap,4H2   ,4HELF1,4H-ELF,4H2   ,
     *4HRho+,4HMolG,4Hraph,
     *4HLap+,4HMolG,4Hraph,   
     *4HMol.,
     *4H Gra,4Hph  ,4HGrad,4HRho ,4HTraj/                                                    
                                                                        
                                                                        
      DO 1 I=1,3                                                        
 1    NAMEI (I+16) = NAMEF (I+ (NFUN-1 )*3 )                             
      RETURN                                                            
      END                                                               
                                                                        
C     ------------------------------------------------------------------
      SUBROUTINE STAR(X,Y,Z)                                            
C     ------------------------------------------------------------------
                                                                        
      IMPLICIT DOUBLE PRECISION(A-H,O-Z)                                
                                                                        
      COMMON/INFDIM/ XLEN,YLEN,XINC,YINC,SCALE,X0,Y0,Z0,EULER1,         
     *               EULER2,EULER3,NXPOINT,NYPOINT                      
                                                                        
C     plots a star in x,y,z ( plot coord.)                              
                                                                        
      SN1= .06D0/SCALE                                                  
      SN2= .04D0/SCALE                                                  
      SN3= .0424/SCALE                                                  
      SN4= .0283/SCALE                                                  
                                                                        
      CALL PLOT (X-SN1,Y,3)                                             
      IF(DABS(Z).GE.1.D-5) GO TO 1                                      
      CALL PLOT (X+SN1,Y,2)                                             
      CALL PLOT (X,Y+SN1,3)                                             
      CALL PLOT (X,Y-SN1,2)                                             
      CALL PLOT (X+SN3,Y+SN3,3)                                         
      CALL PLOT (X-SN3,Y-SN3,2)                                         
      CALL PLOT (X+SN3,Y-SN3,3)                                         
      CALL PLOT (X-SN3,Y+SN3,2)                                         
      RETURN                                                            
    1 CONTINUE                                                          
      CALL PLOT (X-SN2,Y,2)                                             
      CALL PLOT (X+SN2,Y,3)                                             
      CALL PLOT (X+SN1,Y,2)                                             
      CALL PLOT (X,Y+SN1,3)                                             
      CALL PLOT (X,Y+SN2,2)                                             
      CALL PLOT (X,Y-SN2,3)                                             
      CALL PLOT (X,Y-SN1,2)                                             
      CALL PLOT (X+SN3,Y+SN3,3)                                         
      CALL PLOT (X+SN4,Y+SN4,2)                                         
      CALL PLOT (X-SN4,Y-SN4,3)                                         
      CALL PLOT (X-SN3,Y-SN3,2)                                         
      CALL PLOT (X+SN3,Y-SN3,3)                                         
      CALL PLOT (X+SN4,Y-SN4,2)                                         
      CALL PLOT (X-SN4,Y+SN4,3)                                         
      CALL PLOT (X-SN3,Y+SN3,2)                                         
      RETURN                                                            
      END                                                               
                                                                        
C     ------------------------------------------------------------------
      SUBROUTINE NUCLEI(XN,YN,ZN)                                       
C     ------------------------------------------------------------------
                                                                        
      IMPLICIT DOUBLE PRECISION(A-H,O-Z)                                
                                                                        
      COMMON/INFDIM/ XLEN,YLEN,XINC,YINC,SCALE,X0,Y0,Z0,EULER1,         
     *               EULER2,EULER3,NXPOINT,NYPOINT                      

      DATA THRESH/1./
C     
C     In order to avoid to have lot of crosses in solid systems,
C     a threshold (THRESH) has been settled on considered nuclei lying out
C     of molecular plane
C                                                                       
C     plot a cross in xn,yn,zn if zn is lt. 1.d-4                       
C     plot a cross... not crossing if zn ge.1.d-4                       
C     ( coordinates of plot )                                           
                                                                        
      SN1= .06D0/SCALE                                                  
      SN2= .04D0/SCALE                                                  
                                                                        
      CALL PLOT (XN-SN1,YN,3)                                           
      IF (DABS(ZN).GE.1.0D-03) GO TO 1                                  
      CALL PLOT (XN+SN1,YN,2)                                           
      CALL PLOT (XN,YN-SN1,3)                                           
      CALL PLOT (XN,YN+SN1,2)                                           
      RETURN                                                            
    1 IF (DABS(ZN).GE.THRESH) RETURN                                   
      CALL PLOT (XN-SN2,YN,2)                                           
      CALL PLOT (XN+SN2,YN,3)                                           
      CALL PLOT (XN+SN1,YN,2)                                           
      CALL PLOT (XN,YN-SN1,3)                                           
      CALL PLOT (XN,YN-SN2,2)                                           
      CALL PLOT (XN,YN+SN2,3)                                           
      CALL PLOT (XN,YN+SN1,2)                                           
      RETURN                                                            
      END                                                               
                                                                        
C     ------------------------------------------------------------------
      SUBROUTINE TRCOORD(XMOL,YMOL,ZMOL,XPLOT,YPLOT,ZPLOT)              
C     ------------------------------------------------------------------
                                                                        
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)                               
                                                                        
                                                                        
      COMMON /OFFSET/ITYPE,ICENT,KATOM,IEORB,IE,IMO,ICHARG,IXC,IYC,IZC, 
     1 IXX,IYY,IZZ,IXS,IYS,IZS,IRR,IR2,IP,IPSI,IGX,IGY,IGZ,ID2,         
     2 IGXX,IGXY,IGXZ,IGYY,IGYZ,IGZZ                                    
                                                                        
C     COMMON          MODE,NMO,NPRIMS,NCENT          ,CO(1)             
                                                                        
      COMMON/INFDIM/ XLEN,YLEN,XINC,YINC,SCALE,X0,Y0,Z0,EULER1,         
     *               EULER2,EULER3,NXPOINT,NYPOINT                      
                                                                        
      COMMON/PLOTDIM/ XXLEN,YYLEN,HALFXL,HALFYL,
     *SX,SY                                                             
                                                                        
      COMMON/AMATRX/A11,A12,A13,A21,A22,A23,A31,A32,A33                 
                                                                        
      COMMON/UPDOWN/XMIN,XMAX,YMIN,YMAX               
                                                                        
      XPLOT=A11*(XMOL-X0)+A21*(YMOL-Y0)+A31*(ZMOL-Z0)                   
      YPLOT=A12*(XMOL-X0)+A22*(YMOL-Y0)+A32*(ZMOL-Z0)                   
      ZPLOT=A13*(XMOL-X0)+A23*(YMOL-Y0)+A33*(ZMOL-Z0)                   
      XPLOT=XPLOT/SCALE-XMIN/SCALE
      YPLOT=YPLOT/SCALE-YMIN/SCALE
      ZPLOT=ZPLOT/SCALE                                                 
                                                                        
                                                                        
      RETURN                                                            
      END                                                               
                                                                        
C     ------------------------------------------------------------------
      SUBROUTINE RFILSUR (FUN1,FUN2,NFUN,IDIF)
C     ------------------------------------------------------------------
                                                                        
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)                               
                                                                        
      CHARACTER*64 IFILE,IPSIF1,IPSIF2,IFILE3D,IFPLOT,ISASUR 
      CHARACTER*4 IDAS
                                                                        
      COMMON/PARAM/ MAXDIM,MAXX,ILET                                    

      COMMON/INFFIL/ IFILE,IPSIF1,IPSIF2,IFILE3D,IFPLOT,ISASUR 
                                                                        
      COMMON/INFDIM/ XLEN,YLEN,XINC,YINC,SCALE,X0,Y0,Z0,EULER1,         
     *               EULER2,EULER3,NXPOINT,NYPOINT                      

      COMMON/UPDOWN/XMIN,XMAX,YMIN,YMAX               
                                                                        
      COMMON/IO/ IN,IOU                                                 
                                                                        
      DIMENSION FUN1(1),FUN2(1)
                                                                        
      DATA IU3,IU10,IU11/3,10,11/                                         

C     conversion factors
C     uncomment the proper one

C     .148179 from e/Ang3 to e/au3
C     .04149351 from e/Ang5 to e/au5

C     DATA CONVF/.148179/
C     DATA CONVF/.04149351/
      DATA CONVF/1.D0/

 100  FORMAT(2I4)
 101  FORMAT(8(E15.8,1X))
1000  FORMAT(//' The SURFER... file does not match the size given'
     */' in the P2DCRYIN... information file'//) 
1001  FORMAT(//' The two function files contain a different', 
     *' number of grid points')
1002  FORMAT(//' The two function files refer to different xy', 
     *' windows')
                                                                  
      NXPOINT=XLEN/XINC+1.1                                             
      NYPOINT=YLEN/YINC+1.1                                             
      TSHFT=0.D0   
      IF(NFUN.EQ.4)TSHFT=-.5D0
      read(IU11,'(A4)') IDAS
      read(IU11,100) NX,NY
      if((nx.ne.nxpoint).or.(ny.ne.nypoint)) go to 200
      read(IU11,101) XMIN,XMAX        
      read(IU11,101) YMIN,YMAX       
      read(IU11,101) COST,COST

      IF(IDIF.NE.0)THEN
      read(IU10,'(A4)') IDAS
      read(IU10,100) NX1,NY1   
      if((nx.ne.nx1).or.(ny.ne.ny1)) then
      write(iou,1001)
      stop
      endif
      read(IU10,101) XMIN1,XMAX1        
      read(IU10,101) YMIN1,YMAX1       
      read(IU10,101) COST,COST
      if((xmin1.ne.xmin).or.(ymin1.ne.ymin))then
      write(iou,1002)
      stop
      endif
      if((xmax1.ne.xmax).or.(ymax1.ne.ymax))then
      write(iou,1002)
      stop
      endif
      ENDIF
      DO 1 J=1,NYPOINT
      read(iu11,101)(fun1(i),i=1,nxpoint)
      if(idif.eq.1)read(iu10,101)(fun2(i),i=1,nxpoint)
      do 2 k=1,nxpoint
      fun1(k)=fun1(k)*convf+TSHFT      
      if(idif.eq.1)then
      fun2(k)=fun2(k)*convf+TSHFT      
      fun1(k)=fun1(k)-fun2(k)
      endif
2     continue
      write(iu3,rec=j,iostat=ios)(fun1(ii),ii=1,nxpoint)
1     continue
      go to 5
200   write(iou,1000) 
      STOP
 5    return
      end

C     ------------------------------------------------------------------
      SUBROUTINE FUNC (VALUE)                                           
C     ------------------------------------------------------------------
                                                                        
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)                               
                                                                        
C     user defined function                                             
                                                                        
      RETURN                                                            
      END                                                               
C     ----------------------------------------------------------------- 
      SUBROUTINE PLCON                                                  
C     ------------------------------------------------------------------
                                                                        
C     main driver for contours plot                                     
                                                                        
                                                                        
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)                               
	 
      PARAMETER (MAXP=600000)
                                                                        
      COMMON/PROEXT/       CORE(MAXP)                                  
                                                                        
      COMMON/INFDIM/ XLEN,YLEN,XINC,YINC,SCALE,X0,Y0,Z0,EULER1,         
     *               EULER2,EULER3,NXPOINT,NYPOINT                      
                                                                        
      COMMON/EXTMEM/ MAXBLK,NWORDS                                      
                                                                        
      DIMENSION A(1),KCORE(1)                                           
      EQUIVALENCE (A(1),CORE(1))                                        
      EQUIVALENCE (CORE(1),KCORE(1))                                    
                                                                        
      COMMON/PLOTDIM/ XXLEN,YYLEN,HALFXL,HALFYL,
     *SX,SY                                                             
                                                                        
      DATA IU3/3/                                                       
                                                                        
C     evaluates the requirement of extended memory and allocates it     
C     dinamically ( Gould SEL MPX version)                                                      
                                                                        
      NXNY= NXPOINT*NYPOINT                                             
      NTOT=NXNY+NXNY/2 +1
      IF (NTOT.GT.MAXP) THEN
      WRITE(6,1000) NTOT,MAXP
      STOP
      ELSE 
      CONTINUE
      ENDIf
 1000 FORMAT (/,1X,'AMOUNT OF WORKSPACE REQUIRED ',I10,' AMOUNT OF WORKSPACE
     *AVAILABLE ',I10,/,1X,' INCREASE MAXP IN PLCON')
      NXNY2=NXNY*2                                                      
C     NWORDS=NXNY+NXNY2                                                 
C     NWORDS=NWORDS+40000*2                                             
C                                                                       
C     CALL MEMORY (NWORDS,NERROR)                                       
                                                                        
C     put in A the scalar function evaluated at the grid points         
C     x,y values at grid points in cm                                   
                                                                        
      DO 1 IY=1,NYPOINT                                                 
      NREC=IY                                                           
      READ(IU3,REC=NREC,IOSTAT=IOS) (A(NXNY+II ),II=1,NXPOINT)          
      KK=NXPOINT*(IY-1)                                                 
                                                                        
      DO 2 IX=1,NXPOINT                                                 
      A(IX+KK)=A(NXNY +IX)                                              
                                                                        
2     CONTINUE                                                          
1     CONTINUE                                                          
                                                                        
C     sets up the contour plots                                         
      CALL CONTOUR (A(1),KCORE(NXNY2  +1))                              
                                                                        
C     release extended memory (Gould SEL MPX version )                  
                                                                        
C     NWORDS=40000*2                                                    
C     CALL MEMORY(NWORDS,NERROR)                                        
                                                                        
      RETURN                                                            
      END                                                               
C     ----------------------------------------------------------------- 
      SUBROUTINE CONTOUR(A,IA)                                          
C     ----------------------------------------------------------------- 
                                                                        
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)                               
                                                                        
                                                                        
      LOGICAL BETA                                                      
                                                                        
      CHARACTER*64 IFILE,IPSIF1,IPSIF2,IFILE3D,IFPLOT,ISASUR  
                                                                        
      REAL*8 CSIZE                                                      
                                                                        
      COMMON/INFDIM/ XLEN,YLEN,XINC,YINC,SCALE,X0,Y0,Z0,EULER1,         
     *               EULER2,EULER3,NXPOINT,NYPOINT                      
                                                                        
      COMMON/PARAM/ MAXDIM,MAXX,ILET                                    
                                                                        
      COMMON/PLOTDIM/ XXLEN,YYLEN,HALFXL,HALFYL,
     *SX,SY                                                             
                                                                        
      COMMON/RFERM / XREF,YREF,ZREF,IMUL                                
                                                                        
      COMMON/DATA/MODES,MODEG                                           
                                                                        
      COMMON/INFFIL/ IFILE,IPSIF1,IPSIF2,IFILE3D,IFPLOT,ISASUR  
                                                                        
      COMMON/IO/ IN,IOU                                                 
                                                                        
      COMMON/EXCC/ ECONT(50),NEXTRA,NCONT                               
                                                                        
      COMMON/CONT/ AL,BE,CSIZE,WSIZE,BETA,KKK                          
                                                                        
      COMMON/SCUN/ SC1,SC2                                              
                                                                        
                                                                        
      DIMENSION DUMMY(50),KK(52)                                        
      DIMENSION A(NXPOINT,NYPOINT),IA(1)                                
                                                                        
      DATA ZERO/0.D0/                                                   
      DATA KK/2HA ,2HB ,2HC ,2HD ,2HE ,2HF ,2HG ,2HH ,2HI ,2HJ ,        
     +  2HK ,2HL ,2HM , 2HN ,2HO ,2HP ,2HQ ,2HR ,2HS ,2HT ,             
     +  2HU ,2HV ,2HW ,2HX ,2HY ,2HZ ,2HAA,2HBB,2HCC,2HDD,              
     +  2HEE,2HFF,2HGG,2HHH,2HII,2HJJ,2HKK,2HLL,2HMM,2HNN,              
     +  2HOO,2HPP,2HQQ,2HRR,2HSS,2HTT,2HUU,2HVV,2HWW,2HXX,              
     +  2HYY,2HZZ/                                                      
                                                                        
                                                                        
C     in A the scalar function evaluated at the grid points.            
C     x,y values of grid points in cm                                   
C     Each column J of A(I,J)  has a fixed value of y equal to          
C     YINC*(J-1) - plot coordinates in cm-  while                       
C     X goes from 0. (I=1) to xlen ( I=nxpoint)                         
                                                                        
                                                                        
C    *****************************************************************  
C    the following parameters are used by HUNT                          
C    *****************************************************************  
                                                                        
      RNXM1=NXPOINT-1.D0                                                
      RNYM1=NYPOINT-1.D0                                                
      AL=RNXM1/XXLEN                                                     
      SC1=AL                                                            
      AL=1.01/AL                                                        
      BE=RNYM1/YYLEN                                                     
      SC2=BE                                                            
      BE=1.01/BE                                                        
                                                                        
      HLET=XXLEN*1.D-2                                                   
      WLET=HLET*.76D0                                                   
                                                                        
C     character size for lettering of contour plots in cm               
                                                                        
      CSIZE=HLET*SX                                                     
      WSIZE=WLET*SY                                                     
                                                                        
C    *****************************************************************  
C    end of parameters used by HUNT                                     
C    *****************************************************************  
                                                                        
      DUMMY(1)=ECONT(1)                                                 
                                                                        
C     evaluates the difference between neighbouring contour values      
                                                                        
      DO 1 I=2,NCONT                                                    
1     DUMMY(I)=ECONT(I)-ECONT(I-1)                                      
                                                                        
C     loop over contour values                                          
                                                                        
      DO 2 I=1,NCONT                                                    
      BETA=.FALSE.                                                      
      CALL NEWPEN(2)                                                    
      IF(ECONT(I).LT.ZERO) BETA=.TRUE.                                  
      KKK    =KK(I)                                                     
                                                                        
      DO 3 J=1,NYPOINT                                                  
      DO 3 K=1,NXPOINT                                                  
                                                                        
      A(K,J)=A(K,J)-DUMMY(I)                                            
 3    IF(A(K,J).EQ.ZERO) A(K,J)=1.D-10                                  
                                                                        
C     looks for and plots points pertaining to the i-esime              
C     contour plot                                                      
C     ILET= if not zero contour plot labelled by letter                 
C     IA  = scratch integer array (dimension nxpoint,nypoint)           
C                                                                       
                                                                        

      CALL HUNT(A,IA,NXPOINT,NYPOINT,ILET)                              


                                                                        
2     CONTINUE                                                          
                                                                        
      RETURN                                                            
      END                                                               
                                                                        
C     ----------------------------------------------------------------- 
      SUBROUTINE HUNT(A,JA,M,N,INUM)                                    
C     ------------------------------------------------------------------
                                                                        
      IMPLICIT DOUBLE PRECISION(A-H,O-Z)                                
      REAL * 8 CSIZE                                                    
      LOGICAL BOUND,FIRST,BETA                                          
                                                                        
C      extended dummy is a Gould/Sel Fortran specification for          
C      extended memory variables                                        
C                                                                       
      DIMENSION A(M,N),JA(M,N)                                          
      DIMENSION KK(2)                                                   
                                                                        
      COMMON/CONT/   AL,BE,CSIZE,WSIZE,BETA,KKK                         
                                                                        
      DATA IDUE/2/                                                      
      DATA ZERO/0.D0/                                                   
                                                                        
                                                                        
C                                                                       
C THE ARRAY JA MAPS INTO ARRAY A, THE ORIGINAL VERSION USES             
C THE LOW ORDER 7 BITS TO IDENTIFY WHICH CONTOUR ONE IS                 
C CURRENTLY ON. HERE JA TAKES CARE OF THAT.                             
C                                                                       
C+++                                                                    
C      DATA M1,M2,M3,M4/O"177",O"77777777777777777600",O"7",O"170"/     
C+++                                                                    
      DATA M1,M2,M3,M4/O'177',O'600',O'7',O'170'/                       
C+++                                                                    
       DATA KK/41,81/                                                   
       NM1=N-1                                                          
       MM1=M-1                                                          
       N1=N+1                                                           
         MBAD1=M+1                                                      
C                                                                       
C      SET UP INDICATORS                                                
C                                                                       
       DO 10 I=1,M                                                      
       DO 10 J=1,N                                                      
       K=0                                                              
       IF(I.EQ.1) GO TO 20                                              
       IF(A(I,J)*A(I-1,J).LT.0.0D0) K=K+9                               
       IF(I.EQ.M) GO TO 30                                              
20     IF(A(I,J)*A(I+1,J).LT.0.0D0) K=K+33                              
30     IF(J.EQ.1) GO TO 40                                              
       IF(A(I,J)*A(I,J-1).LT.0.D0) K=K+17                               
       IF(J.EQ.N) GO TO 10                                              
40     IF(A(I,J)*A(I,J+1).LT.0.0D0) K=K+65                              
 10     JA(I,J)=IAND(K,M1)                                              
C+++                                                                    
C                                                                       
C      LOOK FOR POINTS WHICH HAVE ONLY ONE INDICATOR SET.               
C                                                                       
700    NPOS=3                                                           
       BOUND=.TRUE.                                                     
       J=1                                                              
       IS=1                                                             
       DO 50 I=1,M                                                      
       IF(IAND(JA(I,J),M3).EQ.1) GO TO 200                              
C+++                                                                    
   50 CONTINUE                                                          
       I=M                                                              
       IS=2                                                             
       DO 60 J=1,N                                                      
       JDUM=IAND(JA(I,J),M3)                                            
       IF(JDUM.EQ.1) GO TO 200                                          
C                                                                       
C+++                                                                    
   60 CONTINUE                                                          
       J=N                                                              
       IS=1                                                             
       DO 70 II=1,M                                                     
         I=MBAD1-II                                                     
       JDUM=IAND(JA(I,J),M3)                                            
       IF(JDUM.EQ.1) GO TO 200                                          
C+++                                                                    
   70 CONTINUE                                                          
       I=1                                                              
       IS=2                                                             
       DO 80 JJ=1,N                                                     
       J=N1-JJ                                                          
       JDUM=IAND(JA(I,J),M3)                                            
       IF(JDUM.EQ.1) GO TO 200                                          
C                                                                       
C+++                                                                    
   80 CONTINUE                                                          
C                                                                       
C      NOW WE MUST TRY THE INTERIOR                                     
C                                                                       
       BOUND=.FALSE.                                                    
       DO 90 I=2,MM1                                                    
       DO 90 J=2,NM1                                                    
       JDUM=IAND(JA(I,J),M3)                                            
       IF(JDUM.EQ.1) GO TO 200                                          
C                                                                       
C++                                                                     
   90 CONTINUE                                                          
C                                                                       
C      NO SUCH ANIMAL - WE CAN"T DO ANYTHING                            
C                                                                       
       BETA=.FALSE.                                                     
       RETURN                                                           
C                                                                       
C      WE HAVE A POINT TO GO FROM                                       
C                                                                       
  200  K=IAND(JA(I,J),M4)                                               
       JA(I,J)=IAND(JA(I,J),M2)                                         
C                                                                       
C+++                                                                    
       FIRST=.TRUE.                                                     
C                                                                       
C      IN THIS CASE K EQUALS 8,16,32, OR 64.                            
C                                                                       
       ASSIGN 210 TO IGO                                                
       GO TO 400                                                        
210    IF(.NOT.BETA) NPOS=2                                             
       FIRST=.FALSE.                                                    
C                                                                       
C      WE COME HERE TO TRY A LINE FROM II,JJ                            
C                                                                       
220    IF(L.EQ.0) GO TO 230                                             
       LDUM=IAND(L,KK(3-NS))                                            
       MDUM=IAND(LDUM,M4)                                               
       IF(MDUM.EQ.0) GO TO 230                                          
C                                                                       
C+++                                                                    
C                                                                       
C      WE HAVE A CROSS LINE FROM II,JJ                                  
C                                                                       
       I=II                                                             
       J=JJ                                                             
C                                                                       
C      FIND THE CROSS LINE WE NEED                                      
C                                                                       
 225   LDUM=IAND(L,M3)                                                  
       IF(LDUM.NE.1) GO TO 240                                          
C                                                                       
C+++                                                                    
C                                                                       
C      HERE THERE IS ONLY 1 SUCH LINE                                   
       JA(I,J)=IAND(JA(I,J),M2)                                         
C                                                                       
C+++                                                                    
       K=L -1                                                           
       ASSIGN 220 TO IGO                                                
       GO TO 400                                                        
C                                                                       
C      HERE WE MUST CHOOSE A LINE                                       
                                                                        
240    IF(NS.EQ.1) GO TO 245                                            
       LDUM=IAND(L,32)                                                  
       IF(LDUM.EQ.0) GO TO 242                                          
C                                                                       
C+++                                                                    
       K=32                                                             
       LL=L-33                                                          
       GO TO 250                                                        
242    K=8                                                              
       LL=L-9                                                           
       GO TO 250                                                        
C                                                                       
C      NS IS 2                                                          
 245   LDUM=IAND(L,64)                                                  
       IF(LDUM.EQ.0) GO TO 247                                          
C                                                                       
C+++                                                                    
       K=64                                                             
       LL=L-65                                                          
       GO TO 250                                                        
247    K=16                                                             
       LL=L-17                                                          
 250   JA(I,J)=IOR(IAND(JA(I,J),M2),IAND(LL,M1))                        
C                                                                       
C+++                                                                    
       ASSIGN 300 TO IGO                                                
       GO TO 400                                                        
C                                                                       
C      NO CROSS LINES LOOK FOR PARALLEL ONES                            
C                                                                       
230    IF(NS.EQ.2) GO TO 280                                            
C                                                                       
C      LAST LINE WAS IN Y DIRECTION, TRY NEAREST Y VALUES               
C                                                                       
       IF(J.EQ.1) GO TO 260                                             
       JDUM=IAND(JA(I,J-1),K)                                           
       IF(JDUM.EQ.0) GO TO 260                                          
C                                                                       
C+++                                                                    
       J=J-1                                                            
 270   L=IAND(JA(I,J),M1)                                               
C                                                                       
C+++                                                                    
       LL=L-K-1                                                         
       GO TO 250                                                        
260    IF(J.EQ.N) GO TO 600                                             
       JDUM=IAND(JA(I,J+1),K)                                           
       IF(JDUM.EQ.0) GO TO 600                                          
C                                                                       
C+++                                                                    
       J=J+1                                                            
       GO TO 270                                                        
C                                                                       
C      LAST LINE WAS IN X DIRECTION, TRY NEAREST VALUES                 
C                                                                       
280    IF(I.EQ.1) GO TO 290                                             
       JDUM=IAND(JA(I-1,J),K)                                           
       IF(JDUM.EQ.0) GO TO 290                                          
C                                                                       
C+++                                                                    
       I=I-1                                                            
       GO TO 270                                                        
290    IF(I.EQ.M) GO TO 600                                             
       JDUM=IAND(JA(I+1,J),K)                                           
       IF(JDUM.EQ.0) GO TO 600                                          
C                                                                       
C+++                                                                    
       I=I+1                                                            
       GO TO 270                                                        
C                                                                       
C      LOOK FOR ANOTHER LINE FROM(I,J)                                  
C                                                                       
 300   LDUM=IAND(LL,KK(3-NS))                                           
       MDUM=IAND(LDUM,M4)                                               
       IF(MDUM.EQ.0) GO TO 220                                          
C                                                                       
C+++                                                                    
C                                                                       
C      THERE IS ONE,WE FIND IT AS EARLIER                               
C                                                                       
       L=LL                                                             
       GO TO 225                                                        
C                                                                       
C      NO LINE, DO WE JOIN UP                                           
C                                                                       
600    IF(BOUND) GO TO 650                                              
       IF(DABS(X-XS).GT.AL.OR.DABS(Y-YS).GT.BE) GO TO 650               
       CALL PLOT (XS,YS,NPOS)                                           
       GO TO 700                                                        
C                                                                       
C      DON"T JOIN, LABEL THIS END TOO                                   
C                                                                       
 650   IF (INUM.EQ.1) CALL LETTER (IDUE,CSIZE,WSIZE,ZERO,X,Y,KKK)       
C+++                                                                    
       GO TO 700                                                        
C                                                                       
C      HERE WE FIND THE NEXT PIECE OF LINE AND CALL PLOT FOR IT         
C                                                                       
400    IF(K.NE.8) GO TO 420                                             
       II=I-1                                                           
       X=DBLE(FLOAT(I))+A(I,J)/(A(II,J)-A(I,J))                         
       GO TO 450                                                        
420    IF(K.NE.16) GO TO 440                                            
       JJ=J-1                                                           
       Y=DBLE(FLOAT(J))+A(I,J)/(A(I,JJ)-A(I,J))                         
       GO TO 470                                                        
440    IF(K.NE.32) GO TO 460                                            
       II=I+1                                                           
       X=DBLE(FLOAT(I))+A(I,J)/(A(I,J)-A(II,J))                         
450    JJ=J                                                             
       NS=1                                                             
       Y=DBLE(FLOAT(J))                                                 
       GO TO 500                                                        
460    JJ=J+1                                                           
       Y=DBLE(FLOAT(J))+A(I,J)/(A(I,J)-A(I,JJ))                         
470    II=I                                                             
       NS=2                                                             
       X=DBLE(FLOAT(I))                                                 
500    CALL UNITTO(X,Y,X,Y)                                             
       IF(.NOT.FIRST) GO TO 519                                         
       XS=X                                                             
       YS=Y                                                             
       XL=X                                                             
       YL=Y                                                             
       REM=0.1                                                          
C+++                                                                    
       IF (INUM.EQ.1) CALL LETTER(IDUE,CSIZE,WSIZE,ZERO,X,Y,KKK)        
C+++                                                                    
       IF(.NOT.BOUND) GO TO 520                                         
       BOUND=IS.EQ.NS                                                   
       GO TO 520                                                        
519    IF(.NOT.BETA) GO TO 520                                          
C+++                                                                    
C                                                                       
C    CALL FOR A DIFFERENT COLOUR PEN FOR DASHED LINES                   
C                                                                       
      CALL NEWPEN(3)                                                    
C                                                                       
C+++                                                                    
      DIST = DSQRT((X - XL)**2 + (Y - YL)**2)                           
  991 IF ((DIST - REM).GE.0.D0) GO TO 999                               
      REM = REM - DIST                                                  
      CALL PLOT (X, Y, NPOS)                                            
      XL = X                                                            
      YL = Y                                                            
      GO TO 994                                                         
  999 XN = (REM/DIST)*(X - XL) + XL                                     
      YN = (REM/DIST)*(Y - YL) + YL                                     
      CALL PLOT (XN, YN, NPOS)                                          
      IF (NPOS.EQ.3) GO TO 998                                          
      NPOS = 3                                                          
      GO TO 996                                                         
  998 NPOS = 2                                                          
  996 XL = XN                                                           
      YL = YN                                                           
      DIST = DIST - REM                                                 
      REM = 0.1                                                         
      GO TO 991                                                         
520    CALL PLOT (X,Y,NPOS)                                             
C+++                                                                    
C                                                                       
 994   L=IAND(JA(II,JJ),M1)                                             
C                                                                       
C+++                                                                    
       L=L+K-KK(NS)                                                     
C+++                                                                    
C                                                                       
       JA(II,JJ)=IOR(IAND(JA(II,JJ),M2),IAND(L,M1))                     
C                                                                       
C+++                                                                    
      GO TO IGO,(210,220,300)                                           
C+++                                                                    
C      RETURN                                                           
C+++                                                                    
      END                                                               
                                                                        
C     ----------------------------------------------------------------- 
      SUBROUTINE UNITTO (XD,YD,XP,YP)                                   
C     ----------------------------------------------------------------- 
                                                                        
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)                               
                                                                        
      COMMON/INFDIM/ XLEN,YLEN,XINC,YINC,SCALE,X0,Y0,Z0,EULER1,         
     *               EULER2,EULER3,NXPOINT,NYPOINT                      

      COMMON/PLOTDIM/ XXLEN,YYLEN,HALFXL,HALFYL,
     *SX,SY                                                             
                                                                        
      COMMON/SCUN/ SC1,SC2                                              
                                                                        
      SC1=(NXPOINT-1.D0)/XXLEN                                           
      SC2=(NYPOINT-1.D0)/YYLEN                                           
      XP= (XD-1.D0)/SC1                                                 
      YP= (YD-1.D0)/SC2                                                 
                                                                        
      RETURN                                                            
      END                                                               
                                                                        
C     ----------------------------------------------------------------- 
      subroutine OUTPUT                                                 
C     ----------------------------------------------------------------- 
                                                                        
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)                               
                                                                        
      CHARACTER*2 SIZE                                                  
                                                                        
      CHARACTER*10 STAR                                                 
      CHARACTER*80 NAME                                                 
                                                                        
      CHARACTER*64 IFILE,IPSIF1,IPSIF2,IFILE3D,IFPLOT,ISASUR 
                                                                        
      COMMON/INFFIL/ IFILE,IPSIF1,IPSIF2,IFILE3D,IFPLOT,ISASUR
                                                                        
      COMMON/INFGRA/ NAME,IPSIZE,IXSYM,IYSYM,ICONT,IDIF,IOVER,          
     *               IPLOT3D,NFUN                                       
                                                                        
      COMMON/INFDIM/ XLEN,YLEN,XINC,YINC,SCALE,X0,Y0,Z0,EULER1,         
     *               EULER2,EULER3,NXPOINT,NYPOINT                      
                                                                        
      COMMON/RFERM / XREF,YREF,ZREF,IMUL                                
                                                                        
      COMMON /C8/ LABEL
                                                                        
      COMMON/EXCC/ ECONT(50),NEXTRA,NCONT                               
                                                                        
      COMMON/IO/ IN,IOU                                                 
                                                                        
                                                                        
      DIMENSION SIZE (2),NAMEF(45)                             
                                                                        
      DATA SIZE/'A3','A4'/                                              
      DATA CONV /.529177/
                                                                        
      DATA STAR/10H**********/                                          
      
      DATA NAMEF /4H Rho,4H    ,4H    ,
     *4HLapl,4Hac. ,4H    ,4HMagn,4H.Gra,4Hdrho,
     *4H ELF,4H    ,4H    ,4HViri,4Hal D,4Hens.,
     *4HG(r),4H    ,4H    ,4HK(r),4H    ,4H    ,
     *4HRhoa,4H-Rho,4Hb   ,4HRho1,4H-Rho,4H2   ,
     *4HLap1,4H-Lap,4H2   ,4HELF1,4H-ELF,4H2   ,
     *4HRho+,4HMolG,4Hraph,
     *4HLap+,4HMolG,4Hraph,   
     *4HMol.,
     *4H Gra,4Hph  ,4HGrad,4HRho ,4HTraj/
                                                                        
1001  FORMAT(/,1X,'Plot title                  ',5X,A80)              
1002  FORMAT(/,1X,'Input file                  ',5X,A40 ,/,            
     *         1X,'File 3-dimensional plot     ',5X,A40 ,/,            
     *         1X,'File for plotter (c. level) ',5X,A40 ,/)            
1003  FORMAT(/,1X,'Xlen(cm)  Ylen(cm)          ',5X,2(F7.3,5X),/,      
     *         1X,'Xinc(cm)  Yinc(cm)          ',5X,2(F7.3,5X),/,      
     *         1X,'Scale (Ang/cm)              ',5X,F7.3,/)            
1004  FORMAT(/,1X,'Paper size                  ',5X,1X,A2)              
1005  FORMAT(/,1X,'Center of plot (au)         ',5X,3(F7.3,5X),/,     
     *         1X,'Center of plot (Ang)        ',5X,3(F7.3,5X),/,     
     *         1X,'Euler angles (degree)       ',5X,3(F7.3,5X),/)     
1006  FORMAT(/,1X,'Symmetry exist across x axis',/)                    
1007  FORMAT(/,1X,'Symmetry exist across y axis',/)                    
1008  FORMAT(/,1X,'Scalar function             ',5X,3A4,/)             
1009  FORMAT(/,1X,'Total number of cont. levels',5X,1X,I2,/,              
     *         1X,'Number of extra contours    ',5X,1X,I2,/)              
1020  FORMAT(/,1X,'Contour levels              ')                      
1021  FORMAT(/,1X,1P,6(E10.3,1X))
                                                                        
      WRITE(IOU,1001) NAME                                              
      WRITE(IOU,1003) XLEN/SCALE,YLEN/SCALE,XINC/SCALE,YINC/SCALE,
     *                SCALE*CONV     
      WRITE(IOU,1004) SIZE(IPSIZE)                                      
      WRITE(IOU,1005)X0,Y0,Z0,X0*CONV,Y0*CONV,Z0*CONV,
     *               EULER1,EULER2,EULER3                      
      IF(IXSYM.NE.0) WRITE(IOU,1006)                                    
      IF(IYSYM.NE.0) WRITE(IOU,1007)                                    
      WRITE(IOU,1008)((NAMEF(I+(NFUN-1)*3)),I=1,3)                      
      IF(NFUN.GE.7) GO TO 4
      WRITE(IOU,1009) NCONT,NEXTRA                                      
      WRITE(IOU,1020)                                                   
      DO 3 I=1,NCONT,6                                                  
      NCO=MIN0(I+5 ,NCONT)                                              
      WRITE(IOU,1021) (ECONT(J),J=I,NCO)                                
 3    CONTINUE                                                          
 4    RETURN                                                            
      END                                                               
C     ------------------------------------------------------------------
      SUBROUTINE DOT (X,Y,Z)                                            
C     ------------------------------------------------------------------
                                                                        
      IMPLICIT DOUBLE PRECISION(A-H,O-Z)                                
                                                                        
      COMMON/INFDIM/ XLEN,YLEN,XINC,YINC,SCALE,X0,Y0,Z0,EULER1,         
     *               EULER2,EULER3,NXPOINT,NYPOINT                      
                                                                        
                                                                        
      COMMON/HP7550/IOUT                                                
                                                                        
C     plots a dot  in x,y,z ( plot coord.)                              
                                                                        
                                                                        
C     determine the radius of circle in user unit(cm)                   
                                                                        
      RADIUS=5.D-2/SCALE                                                
      CALL PLOT(X,Y,3)                                                  
                                                                        
      WRITE(IOUT,'(3HPM;)')                                             
                                                                        
      WRITE(IOUT,'(2HCI,F20.10,1H;)') RADIUS                            
      WRITE(IOUT,'(4HPM2;)')                                            
      WRITE(IOUT,'(3HEP;)')                                             
      CALL NEWPEN(2)                                                    
      WRITE(IOUT,'(3HFP;)')                                             
      CALL NEWPEN(1)                                                    
                                                                        
      RETURN                                                            
      END                                                               
C     ------------------------------------------------------------------
      SUBROUTINE TRPATH 
C     ------------------------------------------------------------------
      implicit double precision (a-h,o-z)                               

      COMMON/PLOTDIM/ XXLEN,YYLEN,HALFXL,HALFYL,SX,SY    
      DIMENSION THICK(0:3)
 
      DATA IIN/12/
      DATA ZERO/0.D0/
      DATA THICK/.2,.40,.40,.60/
      DATA DEFAU/.20/
C
C     unit 12 contains points in crystal coordinate system related to
C             molecular graph or/and grad rho trajectories
C

1000  FORMAT(2I3)
1001  FORMAT(3F15.8)

1     READ(IIN,1000,END=2000) NP,ICRIP
      IF(NP.NE.1) GO TO 10
C
C     put a dot in the position of a (3,-1) c.p.
C
      READ(IIN,1001) X,Y,Z
      CALL TRCOORD(X,Y,Z,XP,YP,ZP)
      IF((XP.GE.XXLEN).OR.(XP.LE.ZERO))GO TO 1
      IF((YP.GE.YYLEN).OR.(YP.LE.ZERO))GO TO 1
      CALL DOT(XP,YP,ZP) 
      GO TO 1
10    CONTINUE
      IF(ICRIP.EQ.0)CALL NEWPEN(4)
      CALL PTHICK(THICK(ICRIP))
      READ(IIN,1001) X,Y,Z
      CALL TRCOORD(X,Y,Z,XP,YP,ZP)
      CALL PLOT(XP,YP,3)
      DO 2 I=2,NP
      READ(IIN,1001) X,Y,Z
      CALL TRCOORD(X,Y,Z,XP,YP,ZP)
      CALL PLOT(XP,YP,2)
 2    CONTINUE
      CALL NEWPEN(1)
      CALL PTHICK(THICK(DEFAU))
      GO TO 1
2000  RETURN
      END
C     ----------------------------------------------------------------  
      SUBROUTINE CHECKIOS (IOSTAT)                                      
C     ----------------------------------------------------------------  
                                                                        
      IF (IOSTAT.NE.0 )  THEN                                           
      WRITE(6,1000) IOSTAT                                              
      STOP                                                              
      ELSE                                                              
      ENDIF                                                             
      RETURN                                                            
                                                                        
 1000 FORMAT(/,1X,' CHECKIOS : IOSTAT = ',I4)                           
                                                                        
      END                                                               
C     --------------------------------------------------------------    
      SUBROUTINE RMATRX (EULER1,EULER2,EULER3)                          
C     --------------------------------------------------------------    
                                                                        
      IMPLICIT DOUBLE PRECISION(A-H,O-Z)                                
C                                                                       
C    CALCULATE THE ROTATION MATRICES FOR TRANSFORMATIONS BETWEEN THE    
C    X'Y' PLANE AND THE MOLECULAR COORDINATE SYSTEM.                    
C                                                                       
      COMMON /AMATRX/ A11,A12,A13,A21,A22,A23,A31,A32,A33               
      COMMON /STUFF/ PI,RADIAN,DEGREE                                   
C                                                                       
      E1=EULER1*RADIAN                                                  
      E2=EULER2*RADIAN                                                  
      E3=EULER3*RADIAN                                                  
      SA=DSIN(E1)                                                       
      SB=DSIN(E2)                                                       
      SC=DSIN(E3)                                                       
      CA=DCOS(E1)                                                       
      CB=DCOS(E2)                                                       
      CC=DCOS(E3)                                                       
      A11=CC*CA-CB*SA*SC                                                
      A12=CC*SA+CB*CA*SC                                                
      A13=SC*SB                                                         
      A21=-SC*CA-CB*SA*CC                                               
      A22=-SC*SA+CB*CA*CC                                               
      A23=CC*SB                                                         
      A31=SB*SA                                                         
      A32=-SB*CA                                                        
      A33=CB                                                            
      RETURN                                                            
      END                                                               
C***********************************************************************0001.000
C        S.UTILPLOT : utility library for HP7550 plotter                0002.000
C                     required by AIMPAC package                        0003.000
C
C        written by Carlo Gatti and Mario Barzaghi , february 1987
                                                                        0004.000
C        subroutines included :   PLOT                                  0005.000
C                                 PLT_Init
C                                 PLT_End
C                                 LETTER                                0007.000
C                                 OCAREA                                0008.000
C                                 WINDOW                                0009.000
C                                 NEWPEN                                0010.000
C                                                                       0011.000
C        september 92: added PLT_INLASER
C***********************************************************************0012.000
C     ------------------------------------------------------------------
      Subroutine PLT_Init (IOut)
C     ------------------------------------------------------------------
      Write (IOut,'(''DF;PA;RO;WD'',A1,'';KY;CV;SP1;'')') Char(3)
      Return
      End
C     ------------------------------------------------------------------0020.000
C     ------------------------------------------------------------------
      Subroutine PLT_Inlaser (IOut)
C     ------------------------------------------------------------------
      write(iout,*) 
     *             ' E'
      write(iout,*) 
     *            ' &l1O'
      write(iout,*) 
     *            ' %0B'
      Write (IOut,'(''DF;PA;RO;WD'',A1,'';KY;CV;SP1;'')') Char(3)
      Return
      End
C     ------------------------------------------------------------------0020.000
      Subroutine PLT_End (IOut)                                         0021.000
C     ------------------------------------------------------------------0022.000
      Write(IOut,'(''SP0;NR;'')')                                       0023.000
      Return                                                            0024.000
      End                                                               0025.000
C     ------------------------------------------------------------------0026.000
C     ------------------------------------------------------------------0020.000
      Subroutine PLT_EndLaser (IOut)                                         0021.000
C     ------------------------------------------------------------------0022.000
      Write(IOut,'(''SP0;NR;'')')                                       0023.000
      write(iout,*) 
     *             '%0A'
      write(iout,*) 
     *             '&l0H'
      write(iout,*) 
     *             'E'
      Return                                                            0024.000
      End                                                               0025.000
C     ------------------------------------------------------------------0026.000
                                                                        0027.000
      SUBROUTINE PLOT(X,Y,N)                                            0028.000
C     ------------------------------------------------------------------0029.000
      REAL*8 X,Y                                                        0030.000
      COMMON /HP7550/ IOUT                                              0031.000
C                                                                       0032.000
      IF (N.EQ.2) THEN                                                  0033.000
         WRITE(IOUT,'(2HPD,F6.3,1H,,F6.3,1H;)') X,Y                     0034.000
      ELSE                                                              0035.000
         WRITE(IOUT,'(2HPU,F6.3,1H,,F6.3,1H;)') X,Y                     0036.000
      END IF                                                            0037.000
C                                                                       0038.000
      RETURN                                                            0039.000
      END                                                               0040.000
                                                                        0041.000
C     ------------------------------------------------------------------0058.000
      SUBROUTINE PTHICK(PTH)
C     ------------------------------------------------------------------0058.000
      REAL*8 PTH
      COMMON /HP7550/ IOUT                                              0031.000
C
      IF(PTH.LT.5.) THEN
      WRITE(IOUT,'(2HPW,1H ,F6.3,1H;)')PTH
      ELSE
      WRITE (6,*) 'STOP: DECREASE PEN THICKNESS'
      STOP  
      ENDIF
      RETURN
      END
C     ------------------------------------------------------------------0058.000
      SUBROUTINE LETTER (N,HEIGHT,WIDTH,ANG,X,Y,STRING)                 0059.000
C     ------------------------------------------------------------------0060.000
C                                                                       0061.000
C     N      = NUMBER OF CHARACTERS IN 'STRING' (N =< 80)               0062.000
C     HEIGHT = HEIGHT OF CHARACTER IN CENTIMETERS                       0063.000
C     WIDTH  = WIDTH OF CHARACTER IN CENTIMETERS                        0064.000
C     ANG    = ANGLE TO X AXIS IN DEGREES                               0065.000
C     X,Y    = X AND Y COORDINATES IN USER UNITS                        0066.000
C     STRING = HOLLERITH STRING                                         0067.000
C                                                                       0068.000
C     ------------------------------------------------------------------0069.000
      REAL*8  HEIGHT,WIDTH,ANG,X,Y,TORAD,COSA,SINA                      0070.000
      CHARACTER*80 BUFF                                                 0071.000
      INTEGER*4 STRING(1)                                               0072.000
      CHARACTER*1 TERM                                                  0073.000
      PARAMETER (TORAD=3.1415926536/180.)                               0074.000
      COMMON /HP7550/ IOUT                                              0075.000
C                                                                       0076.000
      BUFF(1:80)=' '
      COSA=DCOS(ANG*TORAD)                                              0077.000
      SINA=DSIN(ANG*TORAD)                                              0078.000
      TERM=CHAR(3)                                                      0084.000
      WRITE(IOUT,'(2HLB,A1)') TERM
      WRITE(IOUT,'(2HPU,F20.10,1H,,F20.10,1H;)') X,Y                    0079.000
      WRITE(BUFF,'(2HSI,F10.5,1H,,F10.5,1H;)') WIDTH,HEIGHT             0080.000
      WRITE(IOUT,'(A80)') BUFF                                          0081.000
      WRITE(BUFF,'(2HDI,F10.6,1H,,F10.6,1H;)') COSA,SINA                0082.000
      WRITE(IOUT,'(A80)') BUFF                                          0083.000
      NN=(N+3)/4                                                        0085.000
      WRITE(BUFF,'(20A4)') (STRING(I),I=1,NN)                           0086.000
      WRITE(IOUT,'(3HLB ,A,A1,1H;)') BUFF(1:76),TERM 
      RETURN                                                            0088.000
      END                                                               0089.000
                                                                        0090.000
C     ------------------------------------------------------------------0091.000
      SUBROUTINE OCAREA (XMIN,XMAX,YMIN,YMAX,SIZE,IOUT,SX,SY)           0092.000
C     ------------------------------------------------------------------0093.000
C                                                                       0094.000
C     Definisce l'area utente in modo da avere coordinate               0095.000
C     omogenee su X e Y.                                                0096.000
C                                                                       0097.000
C     Input:                                                            0098.000
C                                                                       0099.000
C     XMIN   valore inferiore di X in coordinate utente                 0100.000
C     XMAX   valore superiore di X in coordinate utente                 0101.000
C     YMIN   valore inferiore di Y in coordinate utente                 0102.000
C     YMAX   valore superiore di Y in coordinate utente                 0103.000
C            ( per Schuss e Plotden sono in cm. )                       0104.000
C     SIZE   formato del foglio (A3 o A4)                               0105.000
C     IOUT   unita' fortran per il plotter                              0106.000
C                                                                       0107.000
C     Output:                                                           0108.000
C                                                                       0109.000
C     SX     converte la coordinata utente lungo X in centimetri        0110.000
C     SY     converte la coordinata utente lungo Y in centimetri        0111.000
C                                                                       0112.000
C     ------------------------------------------------------------------0113.000
      IMPLICIT REAL*8(A-H,O-Z)                                          0114.000
      CHARACTER*2   SIZE                                                0115.000
C                                                                       0116.000
      PARAMETER ( POINTS=.025 )  ! punto grafico in mm. ( 40 x  1 mm )  0117.000
      PARAMETER ( PCM   =400.  ) ! numero di punti grafici per cm       0118.000
C                                                                       0119.000
C     Dimensioni del foglio A4  in punti grafici:                       0120.000
C                                                                       0121.000
      PARAMETER( LA4X=10870 , LA4Y=7600 ,                               0122.000
     .           MA4L=1000  , ! margine sinistro                        0123.000
     .           MA4R=300   , ! margine destro                          0124.000
     .           MA4D=500   , ! margine inferiore                       0125.000
     .           MA4U=500   ) ! margine superiore                       0126.000
C                                                                       0127.000
C     Dimensioni del foglio A3  in punti grafici:                       0128.000
C                                                                       0129.000
      PARAMETER( LA3X=15970 , LA3Y=10870 ,                              0130.000
     .           MA3L=1750  , ! margine sinistro                        0131.000
     .           MA3R=450   , ! margine destro                          0132.000
     .           MA3D=750   , ! margine inferiore                       0133.000
     .           MA3U=910   ) ! margine superiore                       0134.000
C                                                                       0135.000
C     Definizione della pagina per il formato A4 o A3                   0136.000
C                                                                       0137.000
      IF (SIZE.EQ.'A4') THEN                                            0138.000
        IP1X=MA4L                                                       0139.000
        IP1Y=MA4D                                                       0140.000
        IP2X=LA4X-MA4R                                                  0141.000
        IP2Y=LA4Y-MA4U                                                  0142.000
      ELSE                                                              0143.000
        IP1X=MA3L                                                       0144.000
        IP1Y=MA3D                                                       0145.000
        IP2X=LA3X-MA3R                                                  0146.000
        IP2Y=LA3Y-MA3U                                                  0147.000
      ENDIF                                                             0148.000
C                                                                       0149.000
C     Se il disegno e' allungato lungo Y ruota il foglio                0150.000
C                                                                       0151.000
      IF (DABS(YMAX-YMIN).GT.DABS(XMAX-XMIN))   THEN                    0152.000
        WRITE(IOUT,'(''RO90;IP;'')')                                    0153.000
        L=IP2X                                                          0154.000
        IP2X=IP2Y                                                       0155.000
        IP2Y=L                                                          0156.000
      ENDIF                                                             0157.000
C                                                                       0158.000
C     Arrotonda i valori massimi all'intero superiore e i valori        0159.000
C     minimi all'intero inferiore.                                      0160.000
      XMX=DINT(XMAX)                                                    0161.000
      IF(XMAX.GT.XMX)  XMX=XMX+1.D00                                    0162.000
      XMN=DINT(XMIN)                                                    0163.000
      YMX=DINT(YMAX)                                                    0164.000
      IF(YMAX.GT.YMX)  YMX=YMX+1.D00                                    0165.000
      YMN=DINT(YMIN)                                                    0166.000
C                                                                       0167.000
C     Definizione della scala                                           0168.000
C                                                                       0169.000
      DELTAX=XMX-XMN                                                    0170.000
      DELTAY=YMX-YMN                                                    0171.000
      LATOX=DELTAX*PCM                                                  0172.000
      LATOY=DELTAY*PCM                                                  0173.000
      RPAGE=DBLE(LATOX)/DBLE(LATOY)                                     0174.000
C                                                                       0175.000
      IF(DABS(DELTAX)/DABS(DELTAY).LE.RPAGE) THEN                       0176.000
         IP2X=IP1X+LATOY                                                0177.000
         IP2Y=IP1Y+LATOY                                                0178.000
         X=XMN+DELTAY                                                   0179.000
         WRITE(IOUT,'(2HIP,4(1X,I5),3H;SC,4F8.0,1H;)')                  0180.000
     .   IP1X,IP1Y,IP2X,IP2Y, XMN,X,YMN,YMX                             0181.000
      ELSE                                                              0182.000
         IP2X=IP1X+LATOX                                                0183.000
         IP2Y=IP1Y+LATOX                                                0184.000
         Y=YMN+DELTAX                                                   0185.000
         WRITE(IOUT,'(2HIP,4(1X,I5),3H;SC,4F8.0,1H;)')                  0186.000
     .   IP1X,IP1Y,IP2X,IP2Y, XMN,XMX,YMN,Y                             0187.000
      ENDIF                                                             0188.000
C                                                                       0189.000
C     Calcola il valore del punto grafico in coordinate utente lungo    0190.000
C     gli assi X e Y                                                    0191.000
C                                                                       0192.000
      RESX = ( XMX - XMN ) / DBLE ( IP2X - IP1X )                       0193.000
      RESY = ( YMX - YMN ) / DBLE ( IP2Y - IP1Y )                       0194.000
C                                                                       0195.000
C     Calcola il fattore di conversione in centimetri delle             0196.000
C     coordinate utente lungo X e Y                                     0197.000
C                                                                       0198.000
      SX = 0.1D0 * POINTS / RESX                                        0199.000
      SY = 0.1D0 * POINTS / RESY                                        0200.000
C                                                                       0201.000
      RETURN                                                            0202.000
      END                                                               0203.000
                                                                        0204.000
C     ------------------------------------------------------------------0205.000
      SUBROUTINE WINDOW (XMIN,XMAX,YMIN,YMAX,IOUT)                      0206.000
C     ------------------------------------------------------------------0207.000
C                                                                       0208.000
C     Definisce la 'finestra' ove e' possibile plottare.                0209.000
C                                                                       0210.000
C     XMIN   valore inferiore di X in coordinate utente                 0211.000
C     XMAX   valore superiore di X in coordinate utente                 0212.000
C     YMIN   valore inferiore di Y in coordinate utente                 0213.000
C     YMAX   valore superiore di Y in coordinate utente                 0214.000
C     IOUT   unita' fortran per il plotter                              0215.000
C                                                                       0216.000
C     ------------------------------------------------------------------0217.000
      IMPLICIT REAL*8(A-H,O-Z)                                          0218.000
C                                                                       0219.000
C     Arrotonda i valori massimi all'intero superiore e i valori        0220.000
C     minimi all'intero inferiore.                                      0221.000
      XMX=DINT(XMAX)                                                    0222.000
      IF(XMAX.GT.XMX)  XMX=XMX+1.D00                                    0223.000
      XMN=DINT(XMIN)                                                    0224.000
      YMX=DINT(YMAX)                                                    0225.000
      IF(YMAX.GT.YMX)  YMX=YMX+1.D00                                    0226.000
      YMN=DINT(YMIN)                                                    0227.000
C                                                                       0228.000
C     Definisce window                                                  0229.000
C                                                                       0230.000
C     WRITE(IOUT,'(2HIW,3(F8.3,1H,),F8.3,1H;)') XMN,YMN , XMX,YMX       0231.000
C     modified for p2dcrynew.f (CGATTI june 94)
      WRITE(IOUT,'(2HIW,3(F8.3,1H,),F8.3,1H;)') XMIN,YMIN,XMAX,YMAX 
C                                                                       0232.000
      RETURN                                                            0233.000
      END                                                               0234.000
C     ----------------------------------------------------------------- 0235.000
      SUBROUTINE NEWPEN(I)                                              0236.000
C     ----------------------------------------------------------------- 0237.000
                                                                        0238.000
C     select pen number i                                               0239.000
                                                                        0240.000
      COMMON /HP7550/ IOUT                                              0241.000
                                                                        0242.000
      WRITE(IOUT,'(2HSP,I5,1H;)') I                                     0243.000
      RETURN                                                            0244.000
      END                                                               0245.000
C                                                                       0246.000




